## libsbml 5.20.2+dfsg

=== CMakeLists.txt ===
###############################################################################
#
# Description       : CMake build script for libSBML
# Original author(s): Frank Bergmann <fbergman@caltech.edu>
# Organization      : California Institute of Technology
#
# This file is part of libSBML.  Please visit http://sbml.org for more
# information about SBML, and the latest version of libSBML.
#
# Copyright (C) 2013-2017 jointly by the following organizations:
#     1. California Institute of Technology, Pasadena, CA, USA
#     2. EMBL European Bioinformatics Institute (EMBL-EBI), Hinxton, UK
#     3. University of Heidelberg, Heidelberg, Germany
#
# Copyright (C) 2009-2013 jointly by the following organizations:
#     1. California Institute of Technology, Pasadena, CA, USA
#     2. EMBL European Bioinformatics Institute (EMBL-EBI), Hinxton, UK
#
# Copyright (C) 2006-2008 by the California Institute of Technology,
#     Pasadena, CA, USA
#
# Copyright (C) 2002-2005 jointly by the following organizations:
#     1. California Institute of Technology, Pasadena, CA, USA
#     2. Japan Science and Technology Agency, Japan
#
# This library is free software; you can redistribute it and/or modify it
# under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation.  A copy of the license agreement is provided
# in the file named "LICENSE.txt" included with this software distribution
# and also available online as http://sbml.org/software/libsbml/license.html
#
###############################################################################

cmake_minimum_required(VERSION 2.8.12...3.19)
project(libsbml)

set(LIBSBML_ROOT_SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}" CACHE PATH
    "Path to the libSBML root source directory")
set(LIBSBML_ROOT_BINARY_DIR "${CMAKE_CURRENT_BINARY_DIR}" CACHE PATH
    "Path to the libSBML root build directory")

include (CMakeTestCCompiler)
include (CheckCSourceCompiles)
include (CheckCXXSourceCompiles)
include (CheckStructHasMember)
include (CheckLibraryExists)
include (CheckFunctionExists)
include (CheckCCompilerFlag)
include (CheckCSourceRuns)
include (CheckSymbolExists)
include (CheckTypeSize)
if (${CMAKE_VERSION} VERSION_GREATER 2.8.4)
	include(GNUInstallDirs)
else ()
	set (CMAKE_INSTALL_DATADIR "share/libsbml/")
	set (CMAKE_INSTALL_LIBDIR "lib")
	set (CMAKE_INSTALL_INCLUDEDIR "include")
	set (CMAKE_INSTALL_BINDIR "bin")
	set (CMAKE_INSTALL_DATADIR "share")
	set (CMAKE_INSTALL_FULL_LIBDIR "${CMAKE_INSTALL_PREFIX}/lib")
	set (CMAKE_INSTALL_FULL_INCLUDEDIR "${CMAKE_INSTALL_PREFIX}/include")
endif ()

###############################################################################
#
# Parse VERSION.txt to determine the package version
#

set(LIBSBML_VERSION_MAJOR)
set(LIBSBML_VERSION_MINOR)
set(LIBSBML_VERSION_PATCH)
set(LIBSBML_VERSION_RELEASE)
set(LIBSBML_DOTTED_VERSION)

if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/VERSION.txt")

    file(STRINGS "${CMAKE_CURRENT_SOURCE_DIR}/VERSION.txt" VersionString NEWLINE_CONSUME)
    string(STRIP "${VersionString}" VersionString)
    set(LIBSBML_DOTTED_VERSION ${VersionString})
    string(REPLACE "." ";" VersionString "${VersionString}" )
    string(REPLACE "-" ";" VersionString "${VersionString}" )
    list(LENGTH VersionString versionLength)
    list(GET VersionString 0 LIBSBML_VERSION_MAJOR )
    list(GET VersionString 1 LIBSBML_VERSION_MINOR )
    list(GET VersionString 2 LIBSBML_VERSION_PATCH )

    if(${versionLength} GREATER 3)
        list(GET VersionString 3 LIBSBML_VERSION_RELEASE )
    endif()

endif()

# version number needs to be calculated correctly
MATH(EXPR LIBSBML_VERSION_NUMERIC "${LIBSBML_VERSION_MAJOR} * 10000 + ${LIBSBML_VERSION_MINOR} * 100 + ${LIBSBML_VERSION_PATCH}" )
set(PACKAGE_VERSION "${LIBSBML_VERSION_MAJOR}.${LIBSBML_VERSION_MINOR}.${LIBSBML_VERSION_PATCH}${LIBSBML_VERSION_RELEASE}")
set(PACKAGE_NAME "libSBML")

set(PACKAGE_CONFIG_DIR "${CMAKE_INSTALL_LIBDIR}/cmake" CACHE PATH
    "Path into which the cmake config files should be installed")


# PACKAGE_VERSION gets overridden by using other packages, so setting
# the PROJECT_VERSION, which will be used when exporting targets in
# src/CMakeLists.txt
set(PROJECT_VERSION ${PACKAGE_VERSION})

if (WITH_DOXYGEN OR WITH_PYTHON)
  # configure the version for documentation / bindings
  configure_file(
      ${CMAKE_CURRENT_SOURCE_DIR}/docs/src/common-text/libsbml-version.html.in
      ${CMAKE_CURRENT_SOURCE_DIR}/docs/src/common-text/libsbml-version.html
  )
endif()

# add make dist and make check target as they are already familiar for
# everyone using the gnumake build
add_custom_target(dist COMMAND ${CMAKE_MAKE_PROGRAM} package_source)
add_custom_target(check COMMAND ${CMAKE_MAKE_PROGRAM} test)

###############################################################################
#
# The next lines configure the parameters for packaging the binaries.
# They can be invoked with "make package" or "nmake package" or by using
# cpack -G zip|deb|rpm|dmg|nsis
#

set(CMAKE_INSTALL_SYSTEM_RUNTIME_LIBS_NO_WARNINGS ON)
include(InstallRequiredSystemLibraries)

set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "An API library for reading/writing/manipulating SBML.")
set(CPACK_PACKAGE_NAME "${PACKAGE_NAME}")
set(CPACK_PACKAGE_VENDOR "The libSBML Team")
set(CPACK_PACKAGE_CONTACT "LibSBML Team <libsbml-team@googlegroups.com>")
set(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/README.md")
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/COPYING.txt")
set(CPACK_PACKAGE_VERSION_MAJOR "${LIBSBML_VERSION_MAJOR}")
set(CPACK_PACKAGE_VERSION_MINOR "${LIBSBML_VERSION_MINOR}")
set(CPACK_PACKAGE_VERSION_PATCH "${LIBSBML_VERSION_PATCH}")
set(CPACK_RPM_PACKAGE_LICENSE "LGPL")
set(CPACK_RPM_PACKAGE_GROUP "Libraries/Development")
set(CPACK_DEBIAN_PACKAGE_SECTION "Libraries")

set(CPACK_SOURCE_IGNORE_FILES "${CMAKE_CURRENT_BINARY_DIR};/.vs/;/.vscode/;/.svn/;/.libs/;/.deps/;/.bzr/;.*.o$;.*.lo$;.*.la$;${CPACK_SOURCE_IGNORE_FILES};/.DS_Store;/.svnignore;blib;libsbml-dist")

if(UNIX)
    set(CPACK_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}")
    set(CPACK_SET_DESTDIR "ON")
endif()

if(CMAKE_SIZEOF_VOID_P EQUAL 4)
    set(CPACK_DEBIAN_PACKAGE_ARCHITECTURE "i386")
    set(CPACK_RPM_PACKAGE_ARCHITECTURE "i386")
else()
    set(CPACK_DEBIAN_PACKAGE_ARCHITECTURE "amd64")
    set(CPACK_RPM_PACKAGE_ARCHITECTURE "x86_64")
endif()

include(CPack)


# add local modules to module path
set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules;${CMAKE_MODULE_PATH}")

# install find modules, so they can readily be used by others: start with libSBML
set (LIBSBML_FIND_MODULES "${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules/FindLIBSBML.cmake")


###############################################################################
#
# Here we have the main configuration options for libsbml.
#

# Build static / shared library
# option(BUILD_SHARED_LIBS  "Build shared library. (Set to OFF to build static libraries.)" OFF)

# Whether to compile examples
option(WITH_EXAMPLES "Compile the libSBML example programs."  OFF)
option(WITH_CHECK "Enable testing of libSBML."  OFF)

# Which language bindings should be built
option(WITH_CSHARP   "Generate the C# language interface for libSBML."     OFF)
option(WITH_JAVA     "Generate the Java language interface for libSBML."   OFF)
option(WITH_PYTHON   "Generate the Python language interface for libSBML." OFF)
option(WITH_PERL     "Generate the Perl language interface for libSBML."   OFF)
option(WITH_PHP      "Generate the PHP language interface for libSBML."    OFF)
option(WITH_RUBY     "Generate the Ruby language interface for libSBML"    OFF)
option(WITH_R        "Generate the R language interface for libSBML"       OFF)
option(WITH_OCTAVE   "Generate the Octave language interface for libSBML." OFF)
option(WITH_MATLAB   "Generate the MATLAB language interface for libSBML." OFF)
option(WITH_JAVASCRIPT      "Generate the experimental Node.js language interface for libSBML." OFF)
option(WITH_STABLE_PACKAGES "Compile libSBML with all stable packages." OFF)
option(WITH_ALL_PACKAGES    "Compile libSBML with all packages." OFF)

if (WITH_ALL_PACKAGES)
  set(_EXPERIMENTAL_PACKGES "arrays;dyn;REQUIREDELEMENTS")
  foreach(package ${_EXPERIMENTAL_PACKGES})
    string(TOUPPER ${package} package_upper)
    string(CONCAT package_option "ENABLE_" ${package_upper})
    set(${package_option} ON CACHE BOOL "Enable package" FORCE)
  endforeach()
  set(WITH_STABLE_PACKAGES ON CACHE BOOL "Enable stable packages" FORCE)
endif(WITH_ALL_PACKAGES)

if (WITH_STABLE_PACKAGES)
  set(_STABLE_PACKGES "comp;distrib;fbc;groups;layout;multi;qual;render;spatial")
  foreach(package ${_STABLE_PACKGES})
    string(TOUPPER ${package} package_upper)
    string(CONCAT package_option "ENABLE_" ${package_upper})
    set(${package_option} ON CACHE BOOL "Enable package" FORCE)
  endforeach()
endif(WITH_STABLE_PACKAGES)

if (WITH_JAVASCRIPT)

  set(_PF86 "ProgramFiles(x86)")
  find_program(NODE_GYP_EXECUTABLE
        NAMES node-gyp node-gyp.cmd
        PATHS
              /usr/local/bin
              /opt/local/bin
              /usr/bin
              "$ENV{ProgramFilesProgramFiles}/nodejs/"
              "$ENV{ProgramW6432}/nodejs/"
        DOC "The file name of the node-gyp executable."
        )

  find_program(NODEJS_EXECUTABLE
        NAMES node nodeexe
        PATHS
              /usr/local/bin
              /opt/local/bin
              /usr/bin
              "$ENV{ProgramFiles}/nodejs/"
              "$ENV{ProgramW6432}/nodejs/"
        DOC "The file name of the nodejs executable."
        )
  # check that we found node-gyp
  if (NOT NODE_GYP_EXECUTABLE)
        message(FATAL_ERROR
"In oder to build the JavaScript language interface, libSBML needs the
node-gyp executable. Please set the variable named NODE_GYP_EXECUTABLE.")
  endif()

  # ensure that the swig version is high enough for javascript
  if (SWIG_VERSION AND NOT SWIG_VERSION VERSION_GREATER 3.0.1)
        message(FATAL_ERROR
"SWIG version 3.0.2 or greater is needed in order to build the JavaScript
language interface for libSBML, but only version ${SWIG_VERSION} was found.")
  endif()

endif()

# Add an option to compile with all warnings shown
option(WITH_WALL     "Compile with -Wall, so that the compiler will display all warnings." OFF)
mark_as_advanced(WITH_WALL)

if(WITH_WALL)
    if(MSVC OR USING_INTEL)
        add_definitions(/W4)
        string(REPLACE "/W3" "/W4" CMAKE_C_FLAGS "${CMAKE_C_FLAGS}")
        string(REPLACE "/W3" "/W4" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
    else()
        add_definitions(-Wall)
    endif()
endif()

# Add an option to instruct libSBML to not include SBMLTypes.h and other files internally.
option(LIBSBML_USE_STRICT_INCLUDES
"Compile using 'strict includes' rules: libSBML header files won't
use SBMLTypes.h, among others." OFF)
if(LIBSBML_USE_STRICT_INCLUDES)
  add_definitions(-DLIBSBML_USE_STRICT_INCLUDES)
endif(LIBSBML_USE_STRICT_INCLUDES)
mark_as_advanced(LIBSBML_USE_STRICT_INCLUDES)

set(LIBSBML_BUILD_TYPE "native")
if (CMAKE_SIZEOF_VOID_P EQUAL 4)
  set(LIBSBML_BUILD_TYPE "32bit")
else()
  set(LIBSBML_BUILD_TYPE "64bit")
endif()
if (APPLE AND ENABLE_UNIVERSAL)
  set(LIBSBML_BUILD_TYPE "universal")
endif()

# When allocation of memory fails or the libSBML C API is unable to open
# a file, libSBML can exit the current process. By default this behavior
# is disabled.
#
option (EXIT_ON_ERROR "Call exit(-1) in case of allocation or file error." OFF)
mark_as_advanced(EXIT_ON_ERROR)

# Use the version number in the shared library.
#
option (LIBSBML_SHARED_VERSION
"Include version information into the compiled libSBML shared library." ON)
mark_as_advanced(LIBSBML_SHARED_VERSION)

# initial value for xml2 parser will default to ON, 
# unless expat or xerces are chosen
set(WITH_LIBXML_INITIAL ON)
if (WITH_EXPAT OR WITH_XERCES)
set(WITH_LIBXML_INITIAL OFF)
endif()

# Choose the xml parsing library to be used.
option(WITH_EXPAT    "Use the Expat XML parser library."     OFF)

=== examples/c++/CMakeLists.txt ===
## @file    CMakeLists.txt
## @brief   CMake build script for example programs
## @author  Frank T. Bergmann
##
## <!--------------------------------------------------------------------------
## This file is part of libSBML.  Please visit http://sbml.org for more
## information about SBML, and the latest version of libSBML.
##
## Copyright (C) 2013-2018 jointly by the following organizations:
##     1. California Institute of Technology, Pasadena, CA, USA
##     2. EMBL European Bioinformatics Institute (EMBL-EBI), Hinxton, UK
##     3. University of Heidelberg, Heidelberg, Germany
##
## Copyright (C) 2009-2013 jointly by the following organizations:
##     1. California Institute of Technology, Pasadena, CA, USA
##     2. EMBL European Bioinformatics Institute (EMBL-EBI), Hinxton, UK
##
## Copyright (C) 2006-2008 by the California Institute of Technology,
##     Pasadena, CA, USA
##
## Copyright (C) 2002-2005 jointly by the following organizations:
##     1. California Institute of Technology, Pasadena, CA, USA
##     2. Japan Science and Technology Agency, Japan
##
## This library is free software; you can redistribute it and/or modify it
## under the terms of the GNU Lesser General Public License as published by
## the Free Software Foundation.  A copy of the license agreement is provided
## in the file named "LICENSE.txt" included with this software distribution
## and also available online as http://sbml.org/software/libsbml/license.html
## ------------------------------------------------------------------------ -->

include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(BEFORE ${LIBSBML_ROOT_SOURCE_DIR}/src)
include_directories(${LIBSBML_ROOT_SOURCE_DIR}/include)
include_directories(BEFORE ${LIBSBML_ROOT_BINARY_DIR}/src)


if (EXTRA_INCLUDE_DIRS)
include_directories(${EXTRA_INCLUDE_DIRS})
endif(EXTRA_INCLUDE_DIRS)

foreach(example

    addCVTerms
    addCustomValidator
    addingEvidenceCodes_1
    addingEvidenceCodes_2
    addModelHistory
    appendAnnotation
    callExternalValidator
    convertSBML
    convertToL1V1
    createExampleSBML
    echoSBML
    inferUnits
    inlineFunctionDefintions
    convertReactions
    getAllElementsWithNotes
    printAnnotation
    printMath
    printNotes
    printSBML
    printRegisteredPackages
    printSupported
    printUnits
    promoteParameters
    readSBML
    renameSId
    setIdFromNames
    setNamesFromIds
    stripPackage
    translateMath
    translateL3Math
    unsetAnnotation
    unsetNotes
    setAnnotation
    validateSBML

)
    add_executable(example_cpp_${example} ${example}.cpp util.c)
    set_target_properties(example_cpp_${example} PROPERTIES  OUTPUT_NAME ${example})
    target_link_libraries(example_cpp_${example} ${LIBSBML_LIBRARY}-static)

endforeach()

if (WITH_LIBXML)
  add_executable(example_cpp_rngvalidator rngvalidator.cpp util.c)
  set_target_properties(example_cpp_rngvalidator PROPERTIES  OUTPUT_NAME rngvalidator)
  target_link_libraries(example_cpp_rngvalidator ${LIBSBML_LIBRARY}-static)
  target_link_libraries(example_cpp_rngvalidator LIBXML::LIBXML ${EXTRA_LIBS})
endif()

# run examples as test

add_test(NAME test_cxx_addCVTerms
         COMMAND "$<TARGET_FILE:example_cpp_addCVTerms>"
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
         addCVTerms.out.xml
)
add_test(NAME test_cxx_addCustomValidator
         COMMAND "$<TARGET_FILE:example_cpp_addCustomValidator>"
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml

)
add_test(NAME test_cxx_addingEvidenceCodes_1
         COMMAND "$<TARGET_FILE:example_cpp_addingEvidenceCodes_1>"
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
         addingEvidenceCodes_1.out.xml
)
add_test(NAME test_cxx_addingEvidenceCodes_2
         COMMAND "$<TARGET_FILE:example_cpp_addingEvidenceCodes_2>"
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
         addingEvidenceCodes_2.out.xml
)
add_test(NAME test_cxx_addModelHistory
         COMMAND "$<TARGET_FILE:example_cpp_addModelHistory>"
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
         addModelHistory.out.xml
)
add_test(NAME test_cxx_appendAnnotation
         COMMAND "$<TARGET_FILE:example_cpp_appendAnnotation>"
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
         appendAnnotation.out.xml
)
add_test(NAME test_cxx_callExternalValidator
         COMMAND "$<TARGET_FILE:example_cpp_callExternalValidator>"
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
         callExternalValidator.out.xml
)
add_test(NAME test_cxx_convertSBML
         COMMAND "$<TARGET_FILE:example_cpp_convertSBML>"
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
         convertSBML.out.xml
)
add_test(NAME test_cxx_convertToL1V1
         COMMAND "$<TARGET_FILE:example_cpp_convertToL1V1>"
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
         convertToL1V1.out.xml
)
add_test(NAME test_cxx_createExampleSBML
         COMMAND "$<TARGET_FILE:example_cpp_createExampleSBML>"
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
         createExampleSBML.out.xml
)
add_test(NAME test_cxx_echoSBML
         COMMAND "$<TARGET_FILE:example_cpp_echoSBML>"
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
         echoSBML.out.xml
)
add_test(NAME test_cxx_inferUnits
         COMMAND "$<TARGET_FILE:example_cpp_inferUnits>"
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
         inferUnits.out.xml
)
add_test(NAME test_cxx_inlineFunctionDefintions
         COMMAND "$<TARGET_FILE:example_cpp_inlineFunctionDefintions>"
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
         inlineFunctionDefintions.out.xml
)
add_test(NAME test_cxx_convertReactions
         COMMAND "$<TARGET_FILE:example_cpp_convertReactions>"
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
         convertReactions.out.xml
)
add_test(NAME test_cxx_getAllElementsWithNotes
         COMMAND "$<TARGET_FILE:example_cpp_getAllElementsWithNotes>"
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
)
add_test(NAME test_cxx_printAnnotation
         COMMAND "$<TARGET_FILE:example_cpp_printAnnotation>"
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
)
add_test(NAME test_cxx_printMath
         COMMAND "$<TARGET_FILE:example_cpp_printMath>"
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
)
add_test(NAME test_cxx_printNotes
         COMMAND "$<TARGET_FILE:example_cpp_printNotes>"
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
)
add_test(NAME test_cxx_printSBML
         COMMAND "$<TARGET_FILE:example_cpp_printSBML>"
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
)
add_test(NAME test_cxx_printRegisteredPackages
         COMMAND "$<TARGET_FILE:example_cpp_printRegisteredPackages>"
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
         printRegisteredPackages.out.xml
)
add_test(NAME test_cxx_printSupported
         COMMAND "$<TARGET_FILE:example_cpp_printSupported>"
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
         printSupported.out.xml
)
add_test(NAME test_cxx_printUnits
         COMMAND "$<TARGET_FILE:example_cpp_printUnits>"
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
)
add_test(NAME test_cxx_promoteParameters
         COMMAND "$<TARGET_FILE:example_cpp_promoteParameters>"
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
         promoteParameters.out.xml
)
add_test(NAME test_cxx_readSBML
         COMMAND "$<TARGET_FILE:example_cpp_readSBML>"
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
)
add_test(NAME test_cxx_renameSId
         COMMAND "$<TARGET_FILE:example_cpp_renameSId>"
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
         veq
         veqnew
         renameSId.out.xml
)
add_test(NAME test_cxx_setIdFromNames
         COMMAND "$<TARGET_FILE:example_cpp_setIdFromNames>"
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
         setIdFromNames.out.xml
)
add_test(NAME test_cxx_setNamesFromIds
         COMMAND "$<TARGET_FILE:example_cpp_setNamesFromIds>"
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
         setNamesFromIds.out.xml
)

 if(ENABLE_FBC) 

add_test(NAME test_cxx_stripPackage
         COMMAND "$<TARGET_FILE:example_cpp_stripPackage>"
         ${CMAKE_SOURCE_DIR}/examples/sample-models/fbc/fbc_example1.xml
         fbc
         stripPackage.out.xml
)

endif(ENABLE_FBC)

add_test(NAME test_cxx_unsetAnnotation
         COMMAND "$<TARGET_FILE:example_cpp_unsetAnnotation>"
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
         unsetAnnotation.out.xml
)
add_test(NAME test_cxx_unsetNotes
         COMMAND "$<TARGET_FILE:example_cpp_unsetNotes>"
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
         unsetNotes.out.xml
)
add_test(NAME test_cxx_validateSBML
         COMMAND "$<TARGET_FILE:example_cpp_validateSBML>"
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
)

=== examples/c++/comp/CMakeLists.txt ===
## @file    CMakeLists.txt
## @brief   CMake build script for example programs
## @author  Frank T. Bergmann
##
## <!--------------------------------------------------------------------------
## This file is part of libSBML.  Please visit http://sbml.org for more
## information about SBML, and the latest version of libSBML.
##
## Copyright (C) 2013-2018 jointly by the following organizations:
##     1. California Institute of Technology, Pasadena, CA, USA
##     2. EMBL European Bioinformatics Institute (EMBL-EBI), Hinxton, UK
##     3. University of Heidelberg, Heidelberg, Germany
##
## Copyright (C) 2009-2013 jointly by the following organizations: 
##     1. California Institute of Technology, Pasadena, CA, USA
##     2. EMBL European Bioinformatics Institute (EMBL-EBI), Hinxton, UK
##  
## Copyright (C) 2006-2008 by the California Institute of Technology,
##     Pasadena, CA, USA 
##  
## Copyright (C) 2002-2005 jointly by the following organizations: 
##     1. California Institute of Technology, Pasadena, CA, USA
##     2. Japan Science and Technology Agency, Japan
## 
## This library is free software; you can redistribute it and/or modify it
## under the terms of the GNU Lesser General Public License as published by
## the Free Software Foundation.  A copy of the license agreement is provided
## in the file named "LICENSE.txt" included with this software distribution
## and also available online as http://sbml.org/software/libsbml/license.html
## ------------------------------------------------------------------------ -->


include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(BEFORE ${LIBSBML_ROOT_SOURCE_DIR}/src)
include_directories(${LIBSBML_ROOT_SOURCE_DIR}/include)
include_directories(BEFORE ${LIBSBML_ROOT_BINARY_DIR}/src)


if (EXTRA_INCLUDE_DIRS) 
include_directories(${EXTRA_INCLUDE_DIRS})
endif(EXTRA_INCLUDE_DIRS)

foreach(example 

	flattenModel
	flattenModelAdvanced
	spec_example1
	spec_example2
	spec_example3
	spec_example4
	
)
	add_executable(example_comp_cpp_${example} ${example}.cpp ../util.c)
	set_target_properties(example_comp_cpp_${example} PROPERTIES  OUTPUT_NAME ${example})
	target_link_libraries(example_comp_cpp_${example} ${LIBSBML_LIBRARY}-static)

endforeach()


# build web resolver example
# for which we need libcurl

find_library(LIBCURL_LIBRARY
  NAMES libcurl.lib curl
  PATHS /usr/lib /usr/local/lib
        ${LIBSBML_DEPENDENCY_DIR}/lib
  DOC "The file name of the curl library."
)
find_path(LIBCURL_INCLUDE_DIR
  NAMES curl/curl.h
  PATHS /usr/include /usr/local/include
        ${LIBSBML_DEPENDENCY_DIR}/include
  DOC "The directory containing the curl include files."
)

if (LIBCURL_LIBRARY AND LIBCURL_INCLUDE_DIR)
  include_directories(${CMAKE_CURRENT_SOURCE_DIR})
  include_directories(${LIBCURL_INCLUDE_DIR})
  include_directories(${CMAKE_CURRENT_SOURCE_DIR}/src)
  add_definitions(-DCURL_STATICLIB)
  add_executable(example_comp_cpp_SBMLHttpResolverExample SBMLHttpResolverExample.cpp ../util.c)
  set_target_properties(example_comp_cpp_SBMLHttpResolverExample PROPERTIES  OUTPUT_NAME SBMLHttpResolverExample)
  target_link_libraries(example_comp_cpp_SBMLHttpResolverExample ${LIBSBML_LIBRARY}-static ${LIBCURL_LIBRARY})
  if (WITH_LIBXML)
  	target_link_libraries(example_comp_cpp_SBMLHttpResolverExample ${LIBXML_LIBRARY} ${EXTRA_LIBS})
  endif()
else()
  message(WARNING "comp example: The SBML HTTP Resolver example cannot be built as libcurl was not found.")
endif ()

# install c++ examples
file(GLOB cpp_samples "${CMAKE_CURRENT_SOURCE_DIR}/*.c"
                    "${CMAKE_CURRENT_SOURCE_DIR}/*.cpp"
                    "${CMAKE_CURRENT_SOURCE_DIR}/*.h")
install(FILES ${cpp_samples} DESTINATION ${MISC_PREFIX}examples/c++/comp)

=== examples/c++/render/CMakeLists.txt ===
####################################################################
#
# CMake Build Script for libsbml c++ examples
#
# 


include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(BEFORE ${LIBSBML_ROOT_SOURCE_DIR}/src)
include_directories(${LIBSBML_ROOT_SOURCE_DIR}/include)
include_directories(BEFORE ${LIBSBML_ROOT_BINARY_DIR}/src)

if (EXTRA_INCLUDE_DIRS) 
include_directories(${EXTRA_INCLUDE_DIRS})
endif(EXTRA_INCLUDE_DIRS)

foreach(example 

	addRenderInformation
	convertLayout
	printRenderInformation
	removeRenderInformation
	
)
	add_executable(example_render_cpp_${example} ${example}.cpp ../util.c)
	set_target_properties(example_render_cpp_${example} PROPERTIES  OUTPUT_NAME ${example})
	target_link_libraries(example_render_cpp_${example} ${LIBSBML_LIBRARY}-static)

endforeach()

=== examples/csharp/distrib/CMakeLists.txt ===
####################################################################
#
# CMake Build Script for libsbml C# examples
#
# 

foreach( example
	
	createNormalExample
	createStatisticsExample
	
)

	ADD_CUSTOM_COMMAND(	
		OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${example}.exe
		COMMAND "${CSHARP_EXAMPLE_COMPILER}"
		ARGS -r:${CMAKE_CURRENT_BINARY_DIR}/../../../src/bindings/csharp/libsbmlcsP.dll
			-target:exe
			-out:${example}.exe
			${CSHARP_EXTRA_ARGS}
			${CMAKE_CURRENT_SOURCE_DIR}${PATH_SEP}${example}.cs
		MAIN_DEPENDENCY ${CMAKE_CURRENT_SOURCE_DIR}/${example}.cs
		COMMENT "Build C# example: ${example}") 
	
	add_custom_target(example_distrib_cs_${example} ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/${example}.exe)
	add_dependencies(example_distrib_cs_${example} binding_csharp_managed_lib)
endforeach()

=== examples/csharp/multi/CMakeLists.txt ===
## @file    CMakeLists.txt
## @brief   CMake build script for example programs
## @author  Frank T. Bergmann
##
## <!--------------------------------------------------------------------------
## This file is part of libSBML.  Please visit http://sbml.org for more
## information about SBML, and the latest version of libSBML.
##
## Copyright (C) 2013-2018 jointly by the following organizations:
##     1. California Institute of Technology, Pasadena, CA, USA
##     2. EMBL European Bioinformatics Institute (EMBL-EBI), Hinxton, UK
##     3. University of Heidelberg, Heidelberg, Germany
##
## Copyright (C) 2009-2013 jointly by the following organizations: 
##     1. California Institute of Technology, Pasadena, CA, USA
##     2. EMBL European Bioinformatics Institute (EMBL-EBI), Hinxton, UK
##  
## Copyright (C) 2006-2008 by the California Institute of Technology,
##     Pasadena, CA, USA 
##  
## Copyright (C) 2002-2005 jointly by the following organizations: 
##     1. California Institute of Technology, Pasadena, CA, USA
##     2. Japan Science and Technology Agency, Japan
## 
## This library is free software; you can redistribute it and/or modify it
## under the terms of the GNU Lesser General Public License as published by
## the Free Software Foundation.  A copy of the license agreement is provided
## in the file named "LICENSE.txt" included with this software distribution
## and also available online as http://sbml.org/software/libsbml/license.html
## ------------------------------------------------------------------------ -->

foreach( example
	
	multi_example1
	multi_example2
	multi_example3
	printMulti
	
)

	ADD_CUSTOM_COMMAND(	
		OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${example}.exe
		COMMAND "${CSHARP_EXAMPLE_COMPILER}"
		ARGS -r:${CMAKE_CURRENT_BINARY_DIR}/../../../src/bindings/csharp/libsbmlcsP.dll
			-target:exe
			-out:${example}.exe
			${CSHARP_EXTRA_ARGS}
			${CMAKE_CURRENT_SOURCE_DIR}${PATH_SEP}${example}.cs
		MAIN_DEPENDENCY ${CMAKE_CURRENT_SOURCE_DIR}/${example}.cs
		COMMENT "Build C# example: ${example}") 
	
	add_custom_target(example_multi_cs_${example} ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/${example}.exe)
	add_dependencies(example_multi_cs_${example} binding_csharp_managed_lib)
endforeach()

if(WITH_CSHARP)
# install c# examples
file(GLOB cs_samples "${CMAKE_CURRENT_SOURCE_DIR}/*.cs")
install(FILES ${cs_samples} DESTINATION ${MISC_PREFIX}examples/csharp/multi)
endif()

=== examples/csharp/render/CMakeLists.txt ===
## @file    CMakeLists.txt
## @brief   CMake build script for example programs
## @author  Frank T. Bergmann
##
## <!--------------------------------------------------------------------------
## This file is part of libSBML.  Please visit http://sbml.org for more
## information about SBML, and the latest version of libSBML.
##
## Copyright (C) 2013-2018 jointly by the following organizations:
##     1. California Institute of Technology, Pasadena, CA, USA
##     2. EMBL European Bioinformatics Institute (EMBL-EBI), Hinxton, UK
##     3. University of Heidelberg, Heidelberg, Germany
##
## Copyright (C) 2009-2013 jointly by the following organizations: 
##     1. California Institute of Technology, Pasadena, CA, USA
##     2. EMBL European Bioinformatics Institute (EMBL-EBI), Hinxton, UK
##  
## Copyright (C) 2006-2008 by the California Institute of Technology,
##     Pasadena, CA, USA 
##  
## Copyright (C) 2002-2005 jointly by the following organizations: 
##     1. California Institute of Technology, Pasadena, CA, USA
##     2. Japan Science and Technology Agency, Japan
## 
## This library is free software; you can redistribute it and/or modify it
## under the terms of the GNU Lesser General Public License as published by
## the Free Software Foundation.  A copy of the license agreement is provided
## in the file named "LICENSE.txt" included with this software distribution
## and also available online as http://sbml.org/software/libsbml/license.html
## ------------------------------------------------------------------------ -->

foreach( example
	
	addRenderInformation
	printRenderInformation
)

	ADD_CUSTOM_COMMAND(	
		OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${example}.exe
		COMMAND "${CSHARP_COMPILER}"
		ARGS -r:${CMAKE_CURRENT_BINARY_DIR}/../../../src/bindings/csharp/libsbmlcsP.dll
			-target:exe
			-out:${example}.exe
			${CSHARP_EXTRA_ARGS}
			${CMAKE_CURRENT_SOURCE_DIR}${PATH_SEP}${example}.cs
		MAIN_DEPENDENCY ${CMAKE_CURRENT_SOURCE_DIR}/${example}.cs
		COMMENT "Build C# example: ${example}") 
	
	add_custom_target(example_render_cs_${example} ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/${example}.exe)
	add_dependencies(example_render_cs_${example} binding_csharp_managed_lib)
endforeach()

if(WITH_CSHARP)
# install c# examples
file(GLOB cs_samples "${CMAKE_CURRENT_SOURCE_DIR}/*.cs")
install(FILES ${cs_samples} DESTINATION ${MISC_PREFIX}examples/csharp/render)
endif()

=== examples/java/comp/CMakeLists.txt ===
## @file    CMakeLists.txt
## @brief   CMake build script for example programs
## @author  Frank T. Bergmann
##
## <!--------------------------------------------------------------------------
## This file is part of libSBML.  Please visit http://sbml.org for more
## information about SBML, and the latest version of libSBML.
##
## Copyright (C) 2013-2018 jointly by the following organizations:
##     1. California Institute of Technology, Pasadena, CA, USA
##     2. EMBL European Bioinformatics Institute (EMBL-EBI), Hinxton, UK
##     3. University of Heidelberg, Heidelberg, Germany
##
## Copyright (C) 2009-2013 jointly by the following organizations: 
##     1. California Institute of Technology, Pasadena, CA, USA
##     2. EMBL European Bioinformatics Institute (EMBL-EBI), Hinxton, UK
##  
## Copyright (C) 2006-2008 by the California Institute of Technology,
##     Pasadena, CA, USA 
##  
## Copyright (C) 2002-2005 jointly by the following organizations: 
##     1. California Institute of Technology, Pasadena, CA, USA
##     2. Japan Science and Technology Agency, Japan
## 
## This library is free software; you can redistribute it and/or modify it
## under the terms of the GNU Lesser General Public License as published by
## the Free Software Foundation.  A copy of the license agreement is provided
## in the file named "LICENSE.txt" included with this software distribution
## and also available online as http://sbml.org/software/libsbml/license.html
## ------------------------------------------------------------------------ -->

find_package(Java COMPONENTS Development REQUIRED)

if (JAVA_COMPATIBILITY)
SET(COMPAT_ARGS "-source ${JAVA_COMPATIBILITY} -target ${JAVA_COMPATIBILITY}")
endif()

foreach(file 
		flattenModel
		customResolver
		)
	
	file(TO_NATIVE_PATH ${CMAKE_CURRENT_BINARY_DIR} CURRENT_BIN)
	file(TO_NATIVE_PATH ${CMAKE_CURRENT_BINARY_DIR}/../../../src/bindings/java/libsbmlj.jar CURRENT_JAR )
	file(TO_NATIVE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/${file}.java CURRENT_FILE)
		
	add_custom_command(	
		OUTPUT ${file}.class
		COMMAND "${Java_JAVAC_EXECUTABLE}"
		ARGS -cp ".${FILE_SEP}\"${CURRENT_JAR}\"${FILE_SEP}${CMAKE_CURRENT_SOURCE_DIR}"
			 ${CURRENT_FILE}
			 ${COMPAT_ARGS}
			 -d ${CMAKE_CURRENT_BINARY_DIR}
		MAIN_DEPENDENCY "${CMAKE_CURRENT_SOURCE_DIR}/../../../src/bindings/java/local.i"
		WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
		DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/${file}.java
		COMMENT "Build java example ${file}"
	) 
	
	add_custom_target(example_comp_java_${file} ALL 
		DEPENDS 
		${CMAKE_CURRENT_BINARY_DIR}/${file}.class 
		SOURCES 
		${CMAKE_CURRENT_SOURCE_DIR}/${file}.java 
	)
	
	add_dependencies(example_comp_java_${file} binding_java_jar)
	
endforeach()

if(WITH_JAVA)
# install java examples
file(GLOB java_samples "${CMAKE_CURRENT_SOURCE_DIR}/java/*.java")
install(FILES ${java_samples} DESTINATION ${MISC_PREFIX}examples/java/comp)
endif()

=== examples/java/spatial/CMakeLists.txt ===
## @file    CMakeLists.txt
## @brief   CMake build script for example programs
## @author  Frank T. Bergmann
##
## <!--------------------------------------------------------------------------
## This file is part of libSBML.  Please visit http://sbml.org for more
## information about SBML, and the latest version of libSBML.
##
## Copyright (C) 2013-2018 jointly by the following organizations:
##     1. California Institute of Technology, Pasadena, CA, USA
##     2. EMBL European Bioinformatics Institute (EMBL-EBI), Hinxton, UK
##     3. University of Heidelberg, Heidelberg, Germany
##
## Copyright (C) 2009-2013 jointly by the following organizations: 
##     1. California Institute of Technology, Pasadena, CA, USA
##     2. EMBL European Bioinformatics Institute (EMBL-EBI), Hinxton, UK
##  
## Copyright (C) 2006-2008 by the California Institute of Technology,
##     Pasadena, CA, USA 
##  
## Copyright (C) 2002-2005 jointly by the following organizations: 
##     1. California Institute of Technology, Pasadena, CA, USA
##     2. Japan Science and Technology Agency, Japan
## 
## This library is free software; you can redistribute it and/or modify it
## under the terms of the GNU Lesser General Public License as published by
## the Free Software Foundation.  A copy of the license agreement is provided
## in the file named "LICENSE.txt" included with this software distribution
## and also available online as http://sbml.org/software/libsbml/license.html
## ------------------------------------------------------------------------ -->

find_package(Java COMPONENTS Development REQUIRED)

if (JAVA_COMPATIBILITY)
SET(COMPAT_ARGS "-source ${JAVA_COMPATIBILITY} -target ${JAVA_COMPATIBILITY}")
endif()

foreach(file 
		spatial_example1
		)
	
	file(TO_NATIVE_PATH ${CMAKE_CURRENT_BINARY_DIR} CURRENT_BIN)
	file(TO_NATIVE_PATH ${CMAKE_CURRENT_BINARY_DIR}/../../../src/bindings/java/libsbmlj.jar CURRENT_JAR )
	file(TO_NATIVE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/${file}.java CURRENT_FILE)
		
	add_custom_command(	
		OUTPUT ${file}.class
		COMMAND "${Java_JAVAC_EXECUTABLE}"
		ARGS -cp ".${FILE_SEP}\"${CURRENT_JAR}\"${FILE_SEP}${CMAKE_CURRENT_SOURCE_DIR}"
			 ${CURRENT_FILE}
			 ${COMPAT_ARGS}
			 -d ${CMAKE_CURRENT_BINARY_DIR}
		MAIN_DEPENDENCY "${CMAKE_CURRENT_SOURCE_DIR}/../../../src/bindings/java/local.i"
		WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
		DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/${file}.java
		COMMENT "Build java example ${file}"
	) 
	
	add_custom_target(example_spatial_java_${file} ALL 
		DEPENDS 
		${CMAKE_CURRENT_BINARY_DIR}/${file}.class 
		SOURCES 
		${CMAKE_CURRENT_SOURCE_DIR}/${file}.java 
	)
	
	add_dependencies(example_spatial_java_${file} binding_java_jar)
	
endforeach()

if(WITH_JAVA)
# install java examples
file(GLOB java_samples "${CMAKE_CURRENT_SOURCE_DIR}/java/*.java")
install(FILES ${java_samples} DESTINATION ${MISC_PREFIX}examples/java/spatial)
endif()

=== src/bindings/python/CMakeLists.txt ===
###############################################################################
#
# Description       : CMake build script for libSBML Python bindings
# Original author(s): Frank Bergmann <fbergman@caltech.edu>
# Organization      : California Institute of Technology
#
# This file is part of libSBML.  Please visit http://sbml.org for more
# information about SBML, and the latest version of libSBML.
#
# Copyright (C) 2013-2018 jointly by the following organizations:
#     1. California Institute of Technology, Pasadena, CA, USA
#     2. EMBL European Bioinformatics Institute (EMBL-EBI), Hinxton, UK
#     3. University of Heidelberg, Heidelberg, Germany
#
# Copyright (C) 2009-2013 jointly by the following organizations: 
#     1. California Institute of Technology, Pasadena, CA, USA
#     2. EMBL European Bioinformatics Institute (EMBL-EBI), Hinxton, UK
#  
# Copyright (C) 2006-2008 by the California Institute of Technology,
#     Pasadena, CA, USA 
#  
# Copyright (C) 2002-2005 jointly by the following organizations: 
#     1. California Institute of Technology, Pasadena, CA, USA
#     2. Japan Science and Technology Agency, Japan
# 
# This library is free software; you can redistribute it and/or modify it
# under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation.  A copy of the license agreement is provided
# in the file named "LICENSE.txt" included with this software distribution
# and also available online as http://sbml.org/software/libsbml/license.html
#
###############################################################################

find_package(SWIG REQUIRED)
include(${SWIG_USE_FILE})
find_package(PythonInterp)

# specify that the same python library should be found 
# as the one the selected interpreter uses
set (Python_ADDITIONAL_VERSIONS ${PYTHON_VERSION_STRING})
find_package(PythonLibs)


####################################################################
#
# determine local dependencies, so as to re-swig if one of them changed
# 

file(GLOB SWIG_DEPENDENCIES 
    ${CMAKE_CURRENT_SOURCE_DIR}/*.i 
    ${CMAKE_CURRENT_SOURCE_DIR}/*.h 
    ${CMAKE_CURRENT_SOURCE_DIR}/*.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/*.cmake
    ${CMAKE_CURRENT_SOURCE_DIR}/../swig/*.i
    ${CMAKE_CURRENT_SOURCE_DIR}/../swig/*.h
    )


####################################################################
#
# generate files that include all packages: 
#


# - local-packages.i
file(GLOB DOWNCAST_EXTENSION RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "${CMAKE_CURRENT_SOURCE_DIR}/local-*.i")
list(REMOVE_ITEM DOWNCAST_EXTENSION "local-packages.i")
# - local-packages.i
update_ifile(
    "local-packages.i" 
    ${CMAKE_CURRENT_BINARY_DIR} 
    "${DOWNCAST_EXTENSION}"
)

# - local-downcast.cpp
file(GLOB DOWNCAST_EXTENSION RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "${CMAKE_CURRENT_SOURCE_DIR}/local-downcast-packages-*.cpp")
update_cfile(
    "local-downcast.cpp" 
    ${CMAKE_CURRENT_BINARY_DIR} 
    "${DOWNCAST_EXTENSION}"
)

# - local-downcast-extension.cpp
file(GLOB DOWNCAST_EXTENSION RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "${CMAKE_CURRENT_SOURCE_DIR}/local-downcast-extension-*.cpp")
update_cfile(
    "local-downcast-extension.cpp" 
    ${CMAKE_CURRENT_BINARY_DIR} 
    "${DOWNCAST_EXTENSION}" 
)

# - local-downcast-namespaces.cpp
file(GLOB DOWNCAST_EXTENSION RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "${CMAKE_CURRENT_SOURCE_DIR}/local-downcast-namespaces-*.cpp")
update_cfile(
    "local-downcast-namespaces.cpp" 
    ${CMAKE_CURRENT_BINARY_DIR} 
    "${DOWNCAST_EXTENSION}"
)

# - local-downcast-plugins.cpp
file(GLOB DOWNCAST_EXTENSION RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "${CMAKE_CURRENT_SOURCE_DIR}/local-downcast-plugins-*.cpp")
update_cfile(
    "local-downcast-plugins.cpp" 
    ${CMAKE_CURRENT_BINARY_DIR} 
    "${DOWNCAST_EXTENSION}"
)

# - local-downcast-plugins.cpp
file(GLOB DOWNCAST_EXTENSION RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "${CMAKE_CURRENT_SOURCE_DIR}/local-downcast-astplugins-*.cpp")
update_cfile(
    "local-downcast-astplugins.cpp" 
    ${CMAKE_CURRENT_BINARY_DIR} 
    "${DOWNCAST_EXTENSION}"
)

# - local-downcast-converters.cpp
file(GLOB DOWNCAST_EXTENSION RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "${CMAKE_CURRENT_SOURCE_DIR}/local-downcast-converters-*.cpp")
update_cfile(
    "local-downcast-converters.cpp" 
    ${CMAKE_CURRENT_BINARY_DIR} 
    "${DOWNCAST_EXTENSION}"
)

#
# Remove SWIG wrappers if requested
#
if (LIBSBML_REMOVE_WRAPPERS)
    foreach(file 
        ${CMAKE_CURRENT_BINARY_DIR}/libsbml_wrap.cpp
        ${CMAKE_CURRENT_BINARY_DIR}/pydoc-normal.i
        ${CMAKE_CURRENT_BINARY_DIR}/pydoc-doxygen.i
    )
        if (EXISTS ${file})
            FILE(REMOVE ${file})
        endif()
    endforeach()
endif(LIBSBML_REMOVE_WRAPPERS)

# the Python bindings will only build if some files are generated, 
# for those files to be generated the following python scripts are 
# needed
file(COPY 
    ${CMAKE_CURRENT_SOURCE_DIR}/../swig/libsbmlutils.py  
    "${CMAKE_CURRENT_SOURCE_DIR}/../../../docs/src/utilities/generate-class-name-list.py"
    "${CMAKE_CURRENT_SOURCE_DIR}/../../../docs/src/utilities/generate-converters-list.py"
    DESTINATION ${CMAKE_CURRENT_BINARY_DIR})


# Normally in Python 2 only ascii strings are accepted as input to 
# libSBML functions SWIG >= 3.0.8 allows one to change this behaviour
# such that both ascii and utf-8 strings can be input. This enables
# this behaviour or prints a warning if Swig version is too old.
if (SWIG_FOUND AND PYTHON_VERSION_STRING VERSION_LESS 3.0)
  if (SWIG_VERSION VERSION_GREATER "3.0.7")
    list(APPEND SWIG_EXTRA_ARGS -DUSE_SWIG_PYTHON_2_UNICODE)
    # message(STATUS SWIG_VERSION "${SWIG_VERSION}")
  else()
    message(WARNING 
"Python ${PYTHON_VERSION_STRING} detected and SWIG version ${SWIG_VERSION}
 < 3.0.8, I cannot enable SWIG_PYTHON_2_UNICODE libSBML Python 
 bindings only accept strings as arugments. Please upgrade Swig to a
 version greater than 3.0.8 to enable unicode input in Python 2. See 
 http://www.swig.org/Doc3.0/Python.html for more details.)")
  endif()
endif()

####################################################################
#
# Swig bindings
#
#
add_custom_command(  

    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/libsbml_wrap.cpp
        ${CMAKE_CURRENT_BINARY_DIR}/libsbml.py
        ${CMAKE_CURRENT_BINARY_DIR}/class-list.txt
        ${CMAKE_CURRENT_BINARY_DIR}/libsbml-converters.txt

    COMMAND "${PYTHON_EXECUTABLE}"
    ARGS  "${CMAKE_CURRENT_SOURCE_DIR}/../swig/swigdoc.py"
        --language python
        --top "${LIBSBML_ROOT_SOURCE_DIR}"
        --master "${CMAKE_CURRENT_SOURCE_DIR}/../swig/libsbml.i"
        --output "${CMAKE_CURRENT_BINARY_DIR}/pydoc-doxygen.i"
        ${SWIG_SWIGDOCDEFINES}

    COMMAND "${PYTHON_EXECUTABLE}"
    ARGS  "${CMAKE_CURRENT_BINARY_DIR}/generate-class-name-list.py"
        "${LIBSBML_ROOT_SOURCE_DIR}/src"
        >
        "${CMAKE_CURRENT_BINARY_DIR}/class-list.txt"

    COMMAND "${PYTHON_EXECUTABLE}"
    ARGS  "${CMAKE_CURRENT_BINARY_DIR}/generate-converters-list.py"  
        "${CMAKE_CURRENT_BINARY_DIR}/class-list.txt"
        >
        "${CMAKE_CURRENT_BINARY_DIR}/libsbml-converters.txt"

    COMMAND "${PYTHON_EXECUTABLE}"
    ARGS  "${CMAKE_CURRENT_SOURCE_DIR}/doc-converter/rewrite_pydoc.py"
        -f "${CMAKE_CURRENT_BINARY_DIR}/pydoc-doxygen.i"
        -o "${CMAKE_CURRENT_BINARY_DIR}/pydoc-normal.i"
        -i ${CMAKE_CURRENT_SOURCE_DIR}/../../../docs/src/common-text
        -g ${CMAKE_CURRENT_SOURCE_DIR}/../../../docs/src/common-graphics

    COMMAND "${CMAKE_COMMAND}"
    ARGS  -E rename pydoc-doxygen.i pydoc.i

    COMMAND "${SWIG_EXECUTABLE}"
    ARGS  -I${CMAKE_CURRENT_SOURCE_DIR}/../swig/
        -I${CMAKE_CURRENT_SOURCE_DIR} 
        -I${CMAKE_CURRENT_BINARY_DIR} 
        -I${LIBSBML_ROOT_BINARY_DIR}/src
        -I${LIBSBML_ROOT_SOURCE_DIR}/src
        -I${LIBSBML_ROOT_SOURCE_DIR}/include
        -DGENERATING_DOCS
        -c++
        -python    
        ${SWIG_EXTRA_ARGS}     
        -o ${CMAKE_CURRENT_BINARY_DIR}/libsbml_wrap.cpp 
        ${CMAKE_CURRENT_SOURCE_DIR}/libsbml.i

    COMMAND "${CMAKE_COMMAND}"
    ARGS  -E rename pydoc.i pydoc-doxygen.i

    COMMAND "${CMAKE_COMMAND}"
    ARGS  -E rename libsbml.py libsbml-doxygen.py

    COMMAND "${CMAKE_COMMAND}"
    ARGS  -E rename pydoc-normal.i pydoc.i

    COMMAND "${SWIG_EXECUTABLE}"
    ARGS  -I${CMAKE_CURRENT_SOURCE_DIR}/../swig/
        -I${CMAKE_CURRENT_SOURCE_DIR} 
        -I${CMAKE_CURRENT_BINARY_DIR} 
        -I${LIBSBML_ROOT_BINARY_DIR}/src
        -I${LIBSBML_ROOT_SOURCE_DIR}/src
        -I${LIBSBML_ROOT_SOURCE_DIR}/include
        -c++
        -python    
        ${SWIG_EXTRA_ARGS}     
        -o ${CMAKE_CURRENT_BINARY_DIR}/libsbml_wrap.cpp 
        ${CMAKE_CURRENT_SOURCE_DIR}/libsbml.i

    COMMAND "${CMAKE_COMMAND}"
    ARGS  -E rename pydoc.i pydoc-normal.i 

    COMMAND "${CMAKE_COMMAND}"
    ARGS -DCUR_BIN_DIRECTORY=\"${CMAKE_CURRENT_BINARY_DIR}\"
         -DVERSION=\"${LIBSBML_DOTTED_VERSION}\"
         -P "${CMAKE_CURRENT_SOURCE_DIR}/add_version.cmake"

    COMMAND "${CMAKE_COMMAND}"
    ARGS -DBIN_DIRECTORY=\"${CMAKE_CURRENT_BINARY_DIR}\"
         -DSRC_DIRECTORY=\"${CMAKE_CURRENT_SOURCE_DIR}\"
         -DPYTHON_USE_API2_WARNINGS=\"${PYTHON_USE_API2_WARNINGS}\"
         -P "${CMAKE_CURRENT_SOURCE_DIR}/patch-python.cmake"

    MAIN_DEPENDENCY ${CMAKE_CURRENT_SOURCE_DIR}/libsbml.i
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/CMakeLists.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/doc-converter/rewrite_pydoc.py
        ${CMAKE_CURRENT_SOURCE_DIR}/../swig/swigdoc.py
        ${SWIG_DEPENDENCIES} ${LIBSBML_HEADER_FILES}

    COMMENT "Swig Python source") 

add_custom_target(binding_python_swig ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/libsbml_wrap.cpp )

####################################################################
#
# Build native library
#


include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../swig)
include_directories(${LIBSBML_ROOT_SOURCE_DIR}/include)
include_directories(${PYTHON_INCLUDE_DIRS})
include_directories(BEFORE ${LIBSBML_ROOT_BINARY_DIR}/src)
include_directories(BEFORE ${CMAKE_CURRENT_BINARY_DIR})

if (EXTRA_INCLUDE_DIRS) 
    include_directories(${EXTRA_INCLUDE_DIRS})
endif(EXTRA_INCLUDE_DIRS)

if (MSVC)
    # the build fails when compiled with packages as the object file is too 
    # big adding the big flag makes it work!
    add_definitions(/bigobj)
endif(MSVC)

add_library(binding_python_lib SHARED libsbml_wrap.cpp)
add_dependencies( binding_python_lib binding_python_swig) 

set_target_properties (binding_python_lib PROPERTIES OUTPUT_NAME "_libsbml")
if (UNIX)
    set_target_properties (binding_python_lib PROPERTIES PREFIX "")
    set_target_properties (binding_python_lib PROPERTIES SUFFIX ".so")
else()    
    if (CYGWIN)
        set_target_properties (binding_python_lib PROPERTIES PREFIX "")
        set_target_properties (binding_python_lib PROPERTIES SUFFIX ".dll")
    else()
        set_target_properties (binding_python_lib PROPERTIES SUFFIX ".pyd")  
    endif()
endif()

if(APPLE OR UNIX)
    option (PYTHON_USE_DYNAMIC_LOOKUP
    "Do not actually link against the python library, instead use the undefined lookup mechanism, that ." OFF)
    mark_as_advanced(PYTHON_USE_DYNAMIC_LOOKUP)
endif(APPLE OR UNIX)

if (PYTHON_USE_DYNAMIC_LOOKUP)
    if (APPLE)
        set_target_properties (binding_python_lib PROPERTIES LINK_FLAGS "-undefined dynamic_lookup")
    endif()
    target_link_libraries(binding_python_lib ${LIBSBML_LIBRARY}-static)
else()                                          
    target_link_libraries(binding_python_lib ${LIBSBML_LIBRARY}-static ${PYTHON_LIBRARIES})
endif()


# 
# Determine the python installation directory
#
set(PYTHON_PACKAGE_INSTALL_DIR)
if (UNIX OR CYGWIN OR MINGW)
    execute_process(COMMAND "${PYTHON_EXECUTABLE}" -c "import sys; sys.stdout.write('{}.{}'.format(*sys.version_info[:2]))"
        OUTPUT_VARIABLE PYTHON_VERSION)

=== dev/utilities/build-python/python-src/CMakeLists.txt ===
###############################################################################
#
# 
#
# Description       : CMake build script for compiling and linking the 
#                     python bindings
# Original author(s): Frank Bergmann <fbergman@caltech.edu>
# Organization      : California Institute of Technology
#
# This file is supposed to be called by buildPython32.bat / buildPython64.bat
#
###############################################################################

cmake_minimum_required(VERSION 2.8)
project(_libsbml)

include (CMakeTestCCompiler)
include (CheckCSourceCompiles)
include (CheckCXXSourceCompiles)
include (CheckStructHasMember)
include (CheckLibraryExists)
include (CheckFunctionExists)
include (CheckCCompilerFlag)
include (CheckCSourceRuns)
include (CheckSymbolExists)
include (CheckTypeSize)

find_package(PythonInterp REQUIRED)

# determine the library path and include path
# for the given interpreter
get_filename_component(path "${PYTHON_EXECUTABLE}" PATH)	
file(GLOB python_lib "${path}/libs/python*.lib")
foreach(lib ${python_lib})
  get_filename_component(name "${lib}" NAME)
  string(TOLOWER "${name}" lower)
  if ("${lower}" STREQUAL "python3.lib" 
      OR "${lower}" MATCHES "_d.lib$" 
      OR "${lower}" MATCHES "debug" 
      OR "${lower}" MATCHES "optimized" 
  )
    list(REMOVE_ITEM python_lib "${lib}")
  endif()
endforeach()
set(PYTHON_LIBRARY ${python_lib})
set(PYTHON_INCLUDE_DIR ${path}/include)
find_package(PythonLibs REQUIRED)


include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../swig)
if (CMAKE_SIZEOF_VOID_P EQUAL 4)
include_directories(${CMAKE_SOURCE_DIR}/../../../win32/include)
else()
include_directories(${CMAKE_SOURCE_DIR}/../../../win64/include)
endif()
include_directories(${PYTHON_INCLUDE_DIRS})
include_directories(${DEP_DIR}/include)

add_definitions(-DUSE_COMP 
				-DUSE_FBC 
				-DUSE_QUAL 
				-DUSE_LAYOUT 
				-DUSE_MULTI
				-DUSE_GROUPS
				-DUSE_RENDER
				-DUSE_L3V2EXTENDEDMATH
)


# set build type default
set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Choose the type of build, options are: None (CMAKE_CXX_FLAGS or CMAKE_C_FLAGS are used), Debug, Release, RelWithDebInfo, MinSizeRel" FORCE )


###############################################################################
#
# Set up remaining variables, add option for universal binaries
#
set(BUILD_DEFINITIONS)
if(UNIX)
	if(APPLE)
		add_definitions(-DMACOSX)
		set(BUILD_DEFINITIONS "${BUILD_DEFINITIONS} -DMACOSX")
		
		# On OSX it is common to build universal binaries to support multiple
		# processor architectures. The default behavior is not to build 
		# multiple architectures, as most users might not need that. 
		option(ENABLE_UNIVERSAL "Create Universal Binaries" OFF)
		
		set(CMAKE_OSX_ARCHITECTURES "${CMAKE_OSX_ARCHITECTURES}" CACHE STRING "A semicolon separated list of build architectures to be used")
		if(ENABLE_UNIVERSAL)
			# if universal binaries are requested and none defined so far
			# overwrite them with all three common architectures. If the user 
			# specified their own list of architectures do not touch!
			if (CMAKE_OSX_ARCHITECTURES STREQUAL "")						
				set(CMAKE_OSX_ARCHITECTURES "i386;ppc;x86_64" CACHE STRING "A semicolon separated list of build architectures to be used" FORCE)				
			endif()
		endif(ENABLE_UNIVERSAL)
	else(APPLE)
		add_definitions(-DLINUX)
		
		if (NOT CYGWIN)
			# on cygwin all code is position independent so -fPIC is not needed
			set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-strict-aliasing -fPIC")
			set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fno-strict-aliasing -fPIC")
		endif()
		
		set(BUILD_DEFINITIONS "${BUILD_DEFINITIONS} -DLINUX")
	endif(APPLE)

	add_definitions( -DPACKAGE_VERSION=\"${PACKAGE_VERSION}\"  -DPACKAGE_NAME=\"${PROJECT_NAME}\")
	set(BUILD_DEFINITIONS "${BUILD_DEFINITIONS} -DPACKAGE_VERSION=\"${PACKAGE_VERSION}\"  -DPACKAGE_NAME=\"${PROJECT_NAME}\"")

else(UNIX)
	add_definitions(-DWIN32 -DLIBSBML_EXPORTS -DLIBLAX_EXPORTS)
	set(BUILD_DEFINITIONS "${BUILD_DEFINITIONS} -DWIN32 -DLIBSBML_EXPORTS -DLIBLAX_EXPORTS")
	if(MSVC)
		add_definitions(-D_CRT_SECURE_NO_WARNINGS -D_CRT_NONSTDC_NO_DEPRECATE)
		set(BUILD_DEFINITIONS "${BUILD_DEFINITIONS} -D_CRT_SECURE_NO_WARNINGS")
		option(WITH_STATIC_RUNTIME "Compile using the static MSVC Runtime" OFF)
		if (NOT WITHOUT_STATIC_RUNTIME)
			foreach(flag_var
				CMAKE_CXX_FLAGS CMAKE_CXX_FLAGS_DEBUG CMAKE_CXX_FLAGS_RELEASE
				CMAKE_CXX_FLAGS_MINSIZEREL CMAKE_CXX_FLAGS_RELWITHDEBINFO
				CMAKE_C_FLAGS CMAKE_C_FLAGS_DEBUG CMAKE_C_FLAGS_RELEASE
				CMAKE_C_FLAGS_MINSIZEREL CMAKE_C_FLAGS_RELWITHDEBINFO)
		
				if(${flag_var} MATCHES "/MD")
					string(REGEX REPLACE "/MD" "/MT" ${flag_var} "${${flag_var}}")
				endif(${flag_var} MATCHES "/MD")
			endforeach(flag_var)
		add_definitions( -D_MT)
		endif(NOT WITHOUT_STATIC_RUNTIME)
	
		file(GLOB WIN32_BINARIES ${CMAKE_SOURCE_DIR}/dependencies/bin/*.dll)
		INSTALL(FILES ${WIN32_BINARIES} DESTINATION bin)
		
	elseif(CYGWIN)
		add_definitions(-DCYGWIN)
		set(BUILD_DEFINITIONS "${BUILD_DEFINITIONS} -DCYGWIN")
	elseif(MINGW)
		if(WITH_LIBXML)
			# this is necessary to build with libxml2 on mingw
			add_definitions(-DLIBXML_STATIC)
		endif(WITH_LIBXML)
	endif(MSVC)
	
endif(UNIX)


set(LIB_PATH)
if (CMAKE_SIZEOF_VOID_P EQUAL 4)
	set(LIB_PATH "${CMAKE_SOURCE_DIR}/../install_32/lib")
  include_directories("${CMAKE_SOURCE_DIR}/../install_32/include")
else()
	set(LIB_PATH "${CMAKE_SOURCE_DIR}/../install_64/lib")
  include_directories("${CMAKE_SOURCE_DIR}/../install_64/include")
endif()



find_library(SBML_LIBRARY 
	NAMES libsbml-static.lib
	PATHS ${LIB_PATH} ${DEP_DIR}/lib
)
find_library(XML_LIBRARY 
	NAMES libxml2.lib
	PATHS ${LIB_PATH} ${DEP_DIR}/lib
)
find_library(ICONV_LIBRARY 
	NAMES libiconv.lib iconv.lib
	PATHS ${LIB_PATH} ${DEP_DIR}/lib
)
find_library(BZ2_LIBRARY 
	NAMES libbz2.lib bzip2.lib
	PATHS ${LIB_PATH} ${DEP_DIR}/lib
)

find_library(ZLIB_LIBRARY 
	NAMES zdll.lib zlib.lib
	PATHS ${LIB_PATH} ${DEP_DIR}/lib
)

if (MSVC)
add_definitions(/bigobj)
endif()

set(LIBS 
	${LIBS} ${SBML_LIBRARY} 
	${XML_LIBRARY} ${ICONV_LIBRARY}
	${BZ2_LIBRARY} ${ZLIB_LIBRARY}
	${PYTHON_LIBRARIES}
)


# remove additional list for python3
foreach(lib ${LIBS})
  get_filename_component(name "${lib}" NAME)
  string(TOLOWER "${name}" lower)
  if ("${lower}" STREQUAL "python3.lib" 
      OR "${lower}" MATCHES "_d.lib$" 
      OR "${lower}" MATCHES "debug" 
      OR "${lower}" MATCHES "optimized" 
  )
    list(REMOVE_ITEM LIBS "${lib}")
  endif()
endforeach()

add_library(binding_python_lib SHARED libsbml_wrap.cpp)

set_target_properties (binding_python_lib PROPERTIES OUTPUT_NAME "_libsbml")
if (UNIX)
	set_target_properties (binding_python_lib PROPERTIES PREFIX "")
	set_target_properties (binding_python_lib PROPERTIES SUFFIX ".so")
else()		
	if (CYGWIN)
		set_target_properties (binding_python_lib PROPERTIES PREFIX "")
		set_target_properties (binding_python_lib PROPERTIES SUFFIX ".dll")
	else()
		set(LIBS ${LIBS} ws2_32.lib)
		set_target_properties (binding_python_lib PROPERTIES SUFFIX ".pyd")	
	endif()
endif()

target_link_libraries(binding_python_lib ${LIBS} )

=== src/sbml/conversion/test/CMakeLists.txt ===
## @file    CMakeLists.txt
## @brief   CMake build script
## @author  Frank T. Bergmann
##
## <!--------------------------------------------------------------------------
## This file is part of libSBML.  Please visit http://sbml.org for more
## information about SBML, and the latest version of libSBML.
##
## Copyright (C) 2013-2018 jointly by the following organizations:
##     1. California Institute of Technology, Pasadena, CA, USA
##     2. EMBL European Bioinformatics Institute (EMBL-EBI), Hinxton, UK
##     3. University of Heidelberg, Heidelberg, Germany
##
## Copyright (C) 2009-2013 jointly by the following organizations: 
##     1. California Institute of Technology, Pasadena, CA, USA
##     2. EMBL European Bioinformatics Institute (EMBL-EBI), Hinxton, UK
##  
## Copyright (C) 2006-2008 by the California Institute of Technology,
##     Pasadena, CA, USA 
##  
## Copyright (C) 2002-2005 jointly by the following organizations: 
##     1. California Institute of Technology, Pasadena, CA, USA
##     2. Japan Science and Technology Agency, Japan
## 
## This library is free software; you can redistribute it and/or modify it
## under the terms of the GNU Lesser General Public License as published by
## the Free Software Foundation.  A copy of the license agreement is provided
## in the file named "LICENSE.txt" included with this software distribution
## and also available online as http://sbml.org/software/libsbml/license.html
## ------------------------------------------------------------------------ -->

include(${LIBSBML_ROOT_SOURCE_DIR}/common.cmake)


file(GLOB C_FILES ${CMAKE_CURRENT_SOURCE_DIR}/*.c)

foreach(c_file ${C_FILES})
	set_source_files_properties(${c_file} PROPERTIES LANGUAGE CXX)
endforeach()

file(GLOB CPP_FILES ${CMAKE_CURRENT_SOURCE_DIR}/*.cpp )
file(GLOB H_FILES ${CMAKE_CURRENT_SOURCE_DIR}/*.h )

set(TEST_FILES ${CPP_FILES} ${C_FILES} ${H_FILES})
include_directories(BEFORE ${LIBSBML_ROOT_SOURCE_DIR}/src)
include_directories(BEFORE ${LIBSBML_ROOT_BINARY_DIR}/src)

if (EXTRA_INCLUDE_DIRS) 
 include_directories(${EXTRA_INCLUDE_DIRS})
endif(EXTRA_INCLUDE_DIRS)

add_executable(test_sbml_conversion ${TEST_FILES})
target_link_libraries(test_sbml_conversion ${LIBSBML_LIBRARY}-static CHECK::CHECK)
add_test(test_sbml_conversion_run ${CMAKE_CURRENT_BINARY_DIR}/test_sbml_conversion )
set_tests_properties(test_sbml_conversion_run PROPERTIES ENVIRONMENT 
	"srcdir=${CMAKE_CURRENT_SOURCE_DIR}")

=== debian/changelog ===
libsbml (5.20.2+dfsg-3) unstable; urgency=medium

  * Drop the Python3-Version attribute
    Closes: #1068105
  * Fix doc-base file

 -- Andreas Tille <tille@debian.org>  Sat, 30 Mar 2024 21:36:28 +0100

libsbml (5.20.2+dfsg-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062619

 -- Benjamin Drung <bdrung@debian.org>  Wed, 28 Feb 2024 17:32:20 +0000

libsbml (5.20.2+dfsg-2) unstable; urgency=medium

  * Team upload.
  * d/control: X-Python3-Version: 3.11 (==)
    While this change is not ideal, because of the upcoming necessary
    upload to bring python3.12 support when it becomes the default, it is
    a short term fix to move the python3.12 migration forward.
    (Closes: #1059650)

 -- Étienne Mollier <emollier@debian.org>  Sun, 31 Dec 2023 15:03:26 +0100

libsbml (5.20.2+dfsg-1) unstable; urgency=medium

  * New upstream version
  * add build support for loongarch64
    Closes: #1058906
  * Drop ancient X-Python-Version field (routine-update)
  * Update location of docs in dh_installdocs helpers
  * Use Debian packaged mathjax.js

 -- Andreas Tille <tille@debian.org>  Mon, 18 Dec 2023 14:31:08 +0100

=== debian/control ===
Source: libsbml
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Ivo Maintz <ivo@maintz.de>,
           Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13),
               dh-python,
               cmake,
               dh-exec,
               doxygen,
               swig,
               libxml2-dev,
               python3-dev,
# should be python3-all-dev but build system can only deal with one Python interpreter
               perl,
               libperl-dev,
               default-jdk-headless,
               default-jdk-doc,
               dh-octave,
               r-base-dev,
               r-base-core,
               graphviz,
               zlib1g-dev,
               libbz2-dev,
               libnewlib-dev,
               check,
               mono-devel,
               mono-mcs,
               cli-common-dev,
               mono-runtime-common,
               texlive-latex-base,
               rdfind,
               texlive-latex-extra
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/med-team/libsbml
Vcs-Git: https://salsa.debian.org/med-team/libsbml.git
Homepage: http://www.sbml.org/
Rules-Requires-Root: no
Testsuite: autopkgtest-pkg-python

Package: libsbml5-dev
Architecture: any-amd64 arm64 armel armhf any-i386 loong64 mips64el ppc64el s390x ia64 ppc64 riscv64 sh4 sparc64 x32
Section: libdevel
Depends: libsbml5t64 (= ${binary:Version}),
         ${misc:Depends}
Provides: libsbml-dev
Description: System Biology Markup Language library - development files
 LibSBML is a library designed to help you read, write, manipulate,
 translate, and validate SBML files and data streams. It is not an
 application itself (though it does come with many example programs),
 but rather a library you can embed in your own applications.
 .
 This package contains files necessary for development with libsbml.

Package: libsbml5t64
Replaces: libsbml5
Breaks: libsbml5 (<< ${source:Version})
Architecture: any-amd64 arm64 armel armhf any-i386 loong64 mips64el ppc64el s390x ia64 ppc64 riscv64 sh4 sparc64 x32
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Provides: ${t64:Provides}, libsbml
Multi-Arch: same
Description: System Biology Markup Language library
 LibSBML is a library designed to help you read, write, manipulate,
 translate, and validate SBML files and data streams. It is not an
 application itself (though it does come with many example programs),
 but rather a library you can embed in your own applications.

Package: python3-sbml5
Architecture: any-amd64 arm64 armel armhf any-i386 loong64 mips64el ppc64el s390x ia64 ppc64 riscv64 sh4 sparc64 x32
Section: python
Depends: ${shlibs:Depends},
         ${misc:Depends},
         ${python3:Depends},
         swig
Provides: python3-sbml
Description: System Biology Markup Language library - Python3 bindings
 LibSBML is a library designed to help you read, write, manipulate,
 translate, and validate SBML files and data streams. It is not an
 application itself (though it does come with many example programs),
 but rather a library you can embed in your own applications.
 .
 This package contains the Python3 bindings of LibSBML.

Package: libsbml5-java
Architecture: any-amd64 arm64 armel armhf any-i386 loong64 mips64el ppc64el s390x ia64 ppc64 riscv64 sh4 sparc64 x32
Section: java
Depends: ${shlibs:Depends},
         ${misc:Depends},
         jarwrapper,
         default-jdk-doc
Pre-Depends: ${misc:Pre-Depends}
Provides: libsbml-java
Description: System Biology Markup Language library - Java bindings
 LibSBML is a library designed to help you read, write, manipulate,
 translate, and validate SBML files and data streams. It is not an
 application itself (though it does come with many example programs),
 but rather a library you can embed in your own applications.
 .
 This Package contains the Java bindings of LibSBML.

Package: libsbml5-perl
Architecture: any-amd64 arm64 armel armhf any-i386 loong64 mips64el ppc64el s390x ia64 ppc64 riscv64 sh4 sparc64 x32
Section: perl
Depends: ${shlibs:Depends},
         ${perl:Depends},
         ${misc:Depends}
Provides: libsbml-perl
Description: System Biology Markup Language library - Perl bindings
 LibSBML is a library designed to help you read, write, manipulate,
 translate, and validate SBML files and data streams. It is not an
 application itself (though it does come with many example programs),
 but rather a library you can embed in your own applications.
 .
 This package contains the Perl bindings of LibSBML.

Package: libsbml5-octave
Architecture: any-amd64 arm64 armel armhf any-i386 loong64 mips64el ppc64el s390x ia64 ppc64 riscv64 sh4 sparc64 x32
Section: math
Depends: ${shlibs:Depends},
         ${misc:Depends},
         ${octave:Depends}
Provides: libsbml-octave
Description: System Biology Markup Language library - Octave bindings
 LibSBML is a library designed to help you read, write, manipulate,
 translate, and validate SBML files and data streams. It is not an
 application itself (though it does come with many example programs),
 but rather a library you can embed in your own applications.
 .
 This package contains the Octave bindings of LibSBML.

Package: libsbml5-cil
Architecture: any-amd64 arm64 armel armhf any-i386 loong64 mips64el ppc64el s390x ia64 ppc64 riscv64 sh4 sparc64 x32
Section: cli-mono
Depends: ${shlibs:Depends},
         ${misc:Depends},
         ${cli:Depends},
         libsbml5-dev
Provides: libsbml-cil
Description: System Biology Markup Language library - CLI bindings
 LibSBML is a library designed to help you read, write, manipulate,
 translate, and validate SBML files and data streams. It is not an
 application itself (though it does come with many example programs),
 but rather a library you can embed in your own applications.
 .
 This package contains the CLI bindings of LibSBML.

Package: libsbml5-examples
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Suggests: libsbml5-dev (= ${binary:Version})
Description: System Biology Markup Language library -- example files
 LibSBML is a library designed to help you read, write, manipulate,
 translate, and validate SBML files and data streams. It is not an
 application itself (though it does come with many example programs),
 but rather a library you can embed in your own applications.
 .
 This package contains C/C++, Java, Perl and layout examples.

Package: libsbml5-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends},
         node-mathjax-full
Suggests: libsbml5-dev (= ${binary:Version})
Description: System Biology Markup Language library -- documentation
 LibSBML is a library designed to help you read, write, manipulate,
 translate, and validate SBML files and data streams. It is not an
 application itself (though it does come with many example programs),
 but rather a library you can embed in your own applications.
 .
 This package contains C/C++ documentation.

Package: libsbml5-cil-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends},
         node-mathjax-full
Suggests: libsbml5-dev (= ${binary:Version})
Description: System Biology Markup Language library -- CLI documentation
 LibSBML is a library designed to help you read, write, manipulate,
 translate, and validate SBML files and data streams. It is not an
 application itself (though it does come with many example programs),
 but rather a library you can embed in your own applications.
 .
 This package contains documentation for Mono/CLI bindings

Package: libsbml5-perl-doc
Architecture: all
Section: doc
Depends: ${misc:Depends},
         node-mathjax-full
Suggests: libsbml5-dev (= ${binary:Version})
Multi-Arch: foreign
Description: System Biology Markup Language library -- Perl documentation
 LibSBML is a library designed to help you read, write, manipulate,
 translate, and validate SBML files and data streams. It is not an
 application itself (though it does come with many example programs),
 but rather a library you can embed in your own applications.
 .
 This package contains documentation for Perl bindings

Package: python3-sbml5-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends},
         node-mathjax-full
Suggests: libsbml5-dev (= ${binary:Version})
Description: System Biology Markup Language library - Python3 documentation
 LibSBML is a library designed to help you read, write, manipulate,
 translate, and validate SBML files and data streams. It is not an
 application itself (though it does come with many example programs),
 but rather a library you can embed in your own applications.
 .
 This package contains documentation for Python3 bindings

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# debian/rules for libsbml

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

### define the VARS ###
include /usr/share/dpkg/default.mk
version := $(DEB_VERSION_UPSTREAM)
libpack := libsbml
debtmp := $(CURDIR)/debian/tmp
SRC_TMP := $(CURDIR)/SRC_TMP
# Test for matlab
CMAKE_OPTS := $(shell sed '/MATLAB/d' debian/cmake_opts)
BIND_MATLAB := $(shell which matlab | grep -q matlab && echo 'yes')
ifdef BIND_MATLAB
CMAKE_OPTS := $(shell cat debian/cmake_opts)
endif

# seems we need to use debian/cmake_opts
JDK_PATH:=$(shell readlink -f /usr/bin/javac | sed "s:/bin/javac::")
JAVA_INCLUDE_PATH:=$(JDK_PATH)/include

ifneq (,$(filter $(DEB_HOST_ARCH), mips mipsel))
CMAKE_OPTS += -D'WITH_01_COMPILE:BOOL=ON'
endif

export PYBUILD_NAME=libsbml

### let's do it ###

DEB_COMPRESS_EXCLUDE = .pdf

%:
	dh  $@ --with python3,cli


override_dh_auto_clean:
	### the clean target of the libsbml makefile is highly b0rken ###
	### the switch to cmake didn't result in great approvements ###
	### still inline changes of files ###
	### very ugly ###
	rm -rf build docs/formatted docs/src/doxygen-version-specific.txt docs/src/doxygen-config-cpp.txt \
	docs/src/doxygen-config-csharp.txt docs/src/doxygen-config-perl.txt docs/src/doxygen-config-python.txt \
	docs/src/java-substitutions/libsbmlConstants.java docs/src/libsbml-installation.html docs/src/perlmod/DoxyDocs.pm \
	docs/src/perlmod/DoxyStructure.pm docs/src/perlmod/Makefile docs/src/perlmod/doxyrules.make \
	src/bindings/matlab/runTests.log docs/src/doxygen-config-c.txt src/bindings/matlab/*.mex* docs/src/perlmod \
	docs/src/doxygen_sqlite3.db docs/src/libsbml.py docs/src/common-text/libsbml-version.html
	find src/bindings -name "*.pyc" -delete

override_dh_autoreconf:
	echo "autoreconf -f -i   returns exit code 1 - skip this"

override_dh_auto_configure:
ifdef BIND_MATLAB
	cat debian/control.matlab >> debian/control || true
endif
	mkdir -p build
	cd build ; cmake $(CMAKE_OPTS) ../

override_dh_auto_build:
	cd build ; make

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	echo "no tests"
endif

override_dh_auto_install:
	cd build ; DESTDIR=../debian/tmp make install
	sed 's#formatted/##g' docs/index.html.in > $(debtmp)/usr/share/libsbml/docs/index.html
#	dh_auto_install -O--buildsystem=pybuild # unfortunately there is no setup.py
	set -x ; \
	for pyv in `py3versions -d` ; do \
	    if [ -d $(debtmp)/usr/lib/*/$${pyv}/site-packages/ ] ; then \
		mkdir -p $(debtmp)/usr/lib/$${pyv}/dist-packages ; \
		mv $(debtmp)/usr/lib/*/$${pyv}/site-packages/* $(debtmp)/usr/lib/$${pyv}/dist-packages ; \
	    fi ; \
	done
	dh_auto_install
	find $(debtmp)/usr -type f -name "*.js" -delete
	find $(debtmp)/usr -type f -name "*.md5" -delete
	find $(debtmp)/usr -type f -exec chmod 644 {} +
	find $(debtmp)/usr/lib -name "*.mex*" -exec strip --strip-unneeded {} + || true
	find $(debtmp)/usr/lib -name "*.mex*" -exec strip --remove-section=.comment {} + || true
	dpkg-shlibdeps $(debtmp)/usr/lib/*/octave/site/oct/*/*.mex -Tdebian/libsbml5-octave.substvars
	dh_octave_substvar
	# for some reason the perl library ends up in
	#  debian/tmp/usr/lib/$(DEB_HOST_ARCH)/$(DEB_HOST_ARCH)/perl5
	# try to fix this
	set -x ; \
	for madir in `find debian -name $(DEB_BUILD_MULTIARCH) -type d | sort | uniq` ; do \
	    if [ -d $${madir}/$(DEB_BUILD_MULTIARCH) ] ; then \
	        echo "Moving contents of wrong directory $${madir}/$(DEB_BUILD_MULTIARCH) into place" ; \
		mv $${madir}/$(DEB_BUILD_MULTIARCH)/* $${madir} ; \
		rmdir $${madir}/$(DEB_BUILD_MULTIARCH) ; \
	    fi ; \
	done
	find debian -type f -name "_form*" -delete
ifdef BIND_MATLAB
	dpkg-shlibdeps $(debtmp)/usr/lib/*.mex* -Tdebian/libsbml5-matlab.substvars
endif

override_dh_installexamples:
	dh_installexamples
	for pl in `grep -Rl '#![[:space:]]*/usr/bin/env[[:space:]]\+perl' debian/*/usr/*` ; do \
	    sed -i '1s?^#![[:space:]]*/usr/bin/env[[:space:]]\+perl?#!/usr/bin/perl?' $${pl} ; \
	done

override_dh_installchangelogs:
	dh_installchangelogs NEWS.txt

override_dh_missing:
	find debian -name test.xml -delete
	rm -f debian/tmp/usr/share/libsbml/*.txt \
	      debian/tmp/usr/share/libsbml/README*
	dh_missing

override_dh_dwz:
	echo "Skip dwz: Too few files for multifile optimization"

override_jh_installjavadoc:
	jh_installjavadoc
	rdfind -makesymlinks true -followsymlinks true \
		$$(dpkg -L $$(apt-cache show default-jdk-doc | grep Depends \
		              | awk '{print $$2}') | grep /usr/share/doc/ \
		   | head -n1) \
		debian/libsbml5-java/usr/share/doc/libsbml5-java/
ifeq ($(DH_VERBOSE),1)
	cat results.txt || /bin/true
endif
	rm -f results.txt
